#!/usr/bin/env python3

from daten import *


pixmap=dict()
BASIS=ord('~')-ord('!')+1
m=0

revPush=list()


### gen-funktionen ###
def get_g(i,j,k):

    if i in [1,2,47,48]:
        i0=i
    else:
        i0=-1

    if j in [1,2]:
        j0=j
    else:
        j0=-1

    g=g_list[(i0,j0)]
    return g[k]


def gen(pm,pm_target):
    for j in range(48):
        for i in range(48):
            k=0
            l=i-2
            while l<=(i+2):
                m=j-2
                while m<=j:
                    if (l>=i) and (m==j):
                        m=m+1
                        continue

                    if (l>0) and (l<=48) and (m>0):
                        try:
                            k=k*2+pm[(l,m)]
                        except KeyError:
                            k=k*2+pm[(0,m+1)]

                    m=m+1

                l=l+1
            v=get_g(i,j,k)
            pm_target[(i,j)]=pm_target[(i,j)]^v




### Funktionen fuer uncomp.py ###
def printImg():

    for i in range(48):
        for j in range(48):
            if pixmap[(j,i)]==1:
                r='#'
            else:
                r=' '
            print(r,end='')

        print('')



def pop(p,lev):
    global m

    tmp=m%256
    m=m//256

    i=0
    while tmp<(p[(lev,i)])[1] or tmp>=((p[(lev,i)])[1]+(p[(lev,i)])[0]):
        i=i+1

    m=m*(p[(lev,i)])[0]
    m=m+tmp-(p[(lev,i)])[1]
    return i

def PopGreys(width, height, x_pos, y_pos):

    if width > 2:
        width=width//2
        height=height//2
        PopGreys(width, height, x_pos, y_pos)
        PopGreys(width, height, x_pos+width, y_pos)
        PopGreys(width, height, x_pos, y_pos+height)
        PopGreys(width, height, x_pos+width, y_pos+height)
        return

    b=pop(freqs,0)

    if b&1:
        pixmap[(x_pos,y_pos)]=1

    if b&2:
        pixmap[(x_pos+1,y_pos)]=1

    if b&4:
        pixmap[(x_pos,y_pos+1)]=1

    if b&8:
        pixmap[(x_pos+1,y_pos+1)]=1



def UnComp(lev,width,height,x_pos,y_pos):
    r=pop(probs, lev)
    if r==2: # weiss
        return

    if r==0: #schwarz
        PopGreys(width, height, x_pos, y_pos)
        return

    width=width//2
    height=height//2

    lev=lev+1
    UnComp(lev, width, height, x_pos, y_pos)
    UnComp(lev, width, height, x_pos+width, y_pos)
    UnComp(lev, width, height, x_pos, y_pos+height)
    UnComp(lev, width, height, x_pos+width, y_pos+height)
    return


### Funktionen fuer comp.py ###
def allWhite(x_pos,y_pos,width,height): 
    for i in range(width):
        for j in range(height):
            if pixmap[(x_pos+i,y_pos+j)]!=0:
                return False

    return True


def allBlack(x_pos,y_pos,width,height):
    if width>3:
        width=width//2
        height=height//2
        v1=allBlack(x_pos,y_pos,width,height)
        v2=allBlack(x_pos+width,y_pos,width,height)
        v3=allBlack(x_pos,y_pos+height,width,height)
        v4=allBlack(x_pos+width,y_pos+height,width,height)
        return (v1 and v2 and v3 and v4)

    if pixmap[(x_pos,y_pos)]!=0:
        return True

    if pixmap[(x_pos+1,y_pos)]!=0:
        return True

    if pixmap[(x_pos,y_pos+1)]!=0:
        return True

    if pixmap[(x_pos+1,y_pos+1)]!=0:
        return True

    return False


def PushGreys(x_pos,y_pos, width,height):
    if width>3:
        width=width//2
        height=height//2
        PushGreys(x_pos, y_pos, width, height)
        PushGreys(x_pos+width, y_pos, width, height)
        PushGreys(x_pos, y_pos+height, width, height)
        PushGreys(x_pos+width, y_pos+height,  width, height)
        return

    val=pixmap[(x_pos,y_pos)] | pixmap[(x_pos+1,y_pos)]<<1 | pixmap[x_pos,y_pos+1]<<2 | pixmap[(x_pos+1,y_pos+1)]<<3

    revPush.append(freqs[(0,val)])


def compress(x_pos, y_pos, width, height, lev):
    if allWhite(x_pos,y_pos,width,height):
        revPush.append(probs[(lev,2)])
        return

    if allBlack(x_pos,y_pos,width,height):
        revPush.append(probs[(lev,0)])
        PushGreys(x_pos,y_pos,width,height)
        return

    revPush.append(probs[(lev,1)])
    width=width//2
    height=height//2
    lev=lev+1

    compress(x_pos, y_pos, width, height, lev)
    compress(x_pos+width, y_pos, width, height, lev)
    compress(x_pos, y_pos+height, width, height, lev)
    compress(x_pos+width, y_pos+height, width, height, lev)


